#!BuildIgnore:          post-build-checks
#
# spec file for package openais (Version 0.80.5)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

%if 0%{?suse_version}
##%define _libexecdir %{_libdir}
%define _libexecdir %{_prefix}/libexec
%endif
%define ais_uid         39
%define ais_user	ais
%if 0%{?fedora_version}
%define pkg_group System Environment/Base
%else
%define pkg_group Productivity/Clustering/HA
%endif

Name:           openais
Summary:        The OpenAIS Standards-Based Cluster Framework executive and APIs
Version:        0.80.5
Release:        16.2
License:        BSD 3-Clause
Group:          %{pkg_group}
Url:            http://www.openais.org/
Source0:        %{name}-%{version}.tar.gz
Source1:	openais.init
Patch0: openais-0.76-defaultconfig.patch
#Patch1: revision-1406.patch
#Patch2: revision-1407.patch
#Patch3: revision-1408.patch
#Patch4: revision-1409.patch
#Patch5: revision-1410.patch
#Patch6: revision-1413.patch
#Patch7: revision-1414.patch
#Patch8: revision-1415.patch
#Patch9: revision-1416.patch
#Patch10: revision-1419.patch
#Patch11: revision-1423.patch
#Patch12: revision-1426.patch
#Patch13: revision-1446.patch
#Patch14: revision-1449.patch
#Patch15: revision-1450.patch
#Patch16: revision-1453.patch
#Patch17: revision-1455.patch
#Patch18: revision-1464.patch
#Patch19: revision-1465.patch
#Patch20: revision-1469.patch
#Patch21: revision-1471.patch
#Patch22: revision-1473.patch
#Patch23: revision-1477.patch
#Patch24: revision-1478.patch
#Patch25: revision-1479.patch
#Patch26: revision-1480.patch
#Patch27: revision-1486.patch
#Patch28: revision-1493.patch
#Patch29: revision-1496.patch
#Patch30: revision-1497.patch
#Patch31: revision-1498.patch
#Patch32: revision-1499.patch
#Patch33: revision-1500.patch
#Patch34: revision-1501.patch
#Patch35: revision-1502.patch
#Patch36: revision-1503.patch
#Patch37: revision-1504.patch
#Patch38: revision-1506.patch
#Patch39: revision-1507.patch
#Patch40: revision-1508.patch
#Patch41: revision-1509.patch
#Patch42: revision-1510.patch
#Patch43: revision-1511.patch
#Patch44: revision-1512.patch
#Patch45: revision-1513.patch
#Patch46: revision-1514.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Requires(pre):   /usr/sbin/useradd
Requires(post):  /sbin/chkconfig
Requires(preun): /sbin/chkconfig

%description 
This package contains the openais executive, openais service handlers,
default configuration files and init script.



Authors:
--------
    Steven Dake
    Mark Haverkamp
    Muni Bajpai
    Daniel McNiel
    Miyotaka Sakai
    Daniel Stodden
    Kristen Smith
    Patrick Caulfield
    Fabien Thomas
    Hans Feldt
    Lars Holm
    Anders Eriksson
    Renaud Metrich
    Frederic Hermann
    Alejandro Lopez
    David Teigland
    Robert Peterson
    Abhijith Das

%package -n libopenais2
License:        BSD 3-Clause
Summary:        The OpenAIS Standards-Based Cluster Framework executive and APIs
Group:          %{pkg_group}

%description -n libopenais2
This package contains the openais executive, openais service handlers,
default configuration files and init script.



Authors:
--------
    Steven Dake
    Mark Haverkamp
    Muni Bajpai
    Daniel McNiel
    Miyotaka Sakai
    Daniel Stodden
    Kristen Smith
    Patrick Caulfield
    Fabien Thomas
    Hans Feldt
    Lars Holm
    Anders Eriksson
    Renaud Metrich
    Frederic Hermann
    Alejandro Lopez
    David Teigland
    Robert Peterson
    Abhijith Das

%package -n libopenais-devel
License:        BSD 3-Clause
Summary:        The openais Standards-Based Cluster Framework libraries
Group:          Development/Libraries/C and C++
Requires:       %{name} = %{version}-%{release}
Requires:       libopenais2 = %{version}-%{release}

%description -n libopenais-devel
This package contains the libraries and include files used to develop
using openais APIs.



Authors:
--------
    Steven Dake
    Mark Haverkamp
    Muni Bajpai
    Daniel McNiel
    Miyotaka Sakai
    Daniel Stodden
    Kristen Smith
    Patrick Caulfield
    Fabien Thomas
    Hans Feldt
    Lars Holm
    Anders Eriksson
    Renaud Metrich
    Frederic Hermann
    Alejandro Lopez
    David Teigland
    Robert Peterson
    Abhijith Das

%prep
%setup
%patch0
#%patch1
#%patch2
#%patch3
#%patch4
#%patch5
#%patch6
#%patch7
#%patch8
#%patch9
#%patch10
#%patch11
#%patch12
#%patch13
#%patch14
#%patch15
#%patch16
#%patch17
#%patch18
#%patch19
#%patch20
#%patch21
#%patch22
#%patch23
#%patch24
#%patch25
#%patch26
#%patch27
#%patch28
#%patch29
#%patch30
#%patch31
#%patch32
#%patch33
#%patch34
#%patch35
#%patch36
#%patch37
#%patch38
#%patch39
#%patch40
#%patch41
#%patch42
#%patch43
#%patch44
#%patch45
#%patch46

%build
# -O3 required for performance reasons
# So we get proper debug output, for now we don't compile with O3
#CFLAGS="$(echo '%{optflags}' | sed -e 's/-O[0-9]*//') -O3"
#CFLAGS="$(echo '%{optflags}')"
##make CFLAGS="$RPM_OPT_FLAGS" LIBDIR=%{_libdir}/openais LCRSODIR=%{_libexecdir}/lcrso PREFIX=%{_prefix} OPENAIS_BUILD=DEBUG
make CFLAGS="$CFLAGS"

%install
rm -rf $RPM_BUILD_ROOT
##make LIBDIR=%{_libdir}/openais DESTDIR=$RPM_BUILD_ROOT PREFIX=%{_prefix} LCRSODIR=%{_libexecdir}/lcrso STATICLIBS=NO OPENAIS_BUILD=DEBUG install
make install DESTDIR=$RPM_BUILD_ROOT STATICLIBS=NO
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
mkdir -p $RPM_BUILD_ROOT%{_initrddir}
install -m 644 CHANGELOG LICENSE SECURITY README.devmap README.amf \
	$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/
install -m 755 %{S:1} $RPM_BUILD_ROOT%{_initrddir}/openais
install -m 755 test/openais-cfgtool $RPM_BUILD_ROOT%{_sbindir}
find $RPM_BUILD_ROOT -name '*.a' -type f -print0 | xargs -0 rm -f
find $RPM_BUILD_ROOT -name '*.la' -type f -print0 | xargs -0 rm -f
%if 0%{?suse_version}
ln -sf ../../etc/init.d/openais $RPM_BUILD_ROOT/%{_sbindir}/rcopenais
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%if 0%{?fedora_version}
/usr/sbin/fedora-useradd %{ais_uid} -r -s /sbin/nologin -d '/' -M \
        -c 'openais Standards Based Cluster Framework' %{ais_user} &>/dev/null || :
%else
if
  getent passwd %{ais_user} >/dev/null
then
  : OK hacluster user already present
else
  /usr/sbin/useradd -c "openais Standards Based Cluster Framework" \
      -r -d '/' -u %{ais_uid} %{ais_user} 2>/dev/null || :
fi
%endif

%post
%if 0%{?suse_version}
  %{fillup_and_insserv -n heartbeat}
%else
  /sbin/chkconfig --add openais || :
%endif
/sbin/ldconfig

%preun
%if 0%{?suse_version}
  %stop_on_removal openais
%else
if [ $1 -eq 0 ]; then
  %{_initrddir}/openais stop &>/dev/null || :
fi
%endif
/sbin/chkconfig --del openais || :

%postun
%if 0%{?suse_version}
  %restart_on_update openais
  %{insserv_cleanup}
%else
[ "$1" -ge "1" ] && %{_initrddir}/openais condrestart &>/dev/null || :
%endif
/sbin/ldconfig

%post -n libopenais2 -p /sbin/ldconfig

%postun -n libopenais2 -p /sbin/ldconfig

%files 
%defattr(-,root,root,-)
%dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/LICENSE
%doc %{_docdir}/%{name}-%{version}/SECURITY
%doc %{_docdir}/%{name}-%{version}/README.amf
%{_sbindir}/aisexec
%{_sbindir}/ais-keygen
%{_sbindir}/openais-cfgtool
%dir /etc/ais
%config(noreplace) /etc/ais/openais.conf
%config(noreplace) /etc/ais/amf.conf
%config /etc/ld.so.conf.d/openais-*.conf
%{_initrddir}/openais
%if 0%{?suse_version}
%{_sbindir}/rcopenais
%endif
%dir %{_libexecdir}/lcrso
%{_libexecdir}/lcrso/*.lcrso
%{_mandir}/man8/*.8*
%{_mandir}/man5/openais.conf.5*
##%{_mandir}/man5/amf.conf.5*

%files -n libopenais2
%defattr(-,root,root,-)
%dir %{_libdir}/openais
%{_libdir}/openais/lib*.so.*

%files -n libopenais-devel
%defattr(-,root,root,-)
%dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/CHANGELOG
%doc %{_docdir}/%{name}-%{version}/README.devmap
%dir %{_includedir}/openais/
%dir %{_includedir}/openais/lcr/
%dir %{_includedir}/openais/totem/
%dir %{_includedir}/openais/service
%{_libdir}/openais/lib*.so
%{_includedir}/openais/*.h
%{_includedir}/openais/lcr/*.h
%{_includedir}/openais/totem/*.h
%{_includedir}/openais/service/*.h
%{_mandir}/man3/cpg_*.3*
%{_mandir}/man3/evs_*.3*
##%{_mandir}/man3/confdb_*.3.gz

%changelog
* Wed Feb 18 2009 Carsten Schoene <cs@linux-administrator.com>
- version 0.80.5-1
- Update to new release
* Wed Nov 19 2008 Andrew Beekhof <abeekhof@suse.de>
- version 0.80.3-4
- Update patch to 26c4af74cac1
+ Fix service load order patch which prevented openais from starting
* Fri Nov 14 2008 Andrew Beekhof <abeekhof@suse.de>
- version 0.80.3-3
- Update source tarball to r1661
- Update patch to bbbb59907893
+ Fix nodeid generation to use the node's full ip address (not network address) to ensure uniqueness
+ Start additional services after the default ones
+ Correctly compare addresses with bindnetaddr
+ Fix a message lost during delivery which resulted in checkpoint segfault
+ Fix commit token recieved_flg being incorrect in some rare circumstances
+ Fix rare problem where checkpoint synchronization database could be thrown away
+ Improvements to the default openais.conf file
+ Add a configuraiton option to allow generated nodeids to be limited to 31-bits
* Thu Oct  9 2008 Andrew Beekhof <abeekhof@suse.de>
- version 0.80.3-2
- Update source tarball to r1655
+ Remove IPC scheduling starvation
+ Fix Library queue full messages in some conditions
+ Make sanitizing generated nodeid's optional
+ Create a libopenais2 subpackage as per policy
* Wed Aug 20 2008 Andrew Beekhof <abeekhof@suse.de>
- version 0.80.3-1
- Update source tarball to r1649
+ Add backports of objdb and service shutdown patches
+ Modify the nodeid generation function to never return a negative value
* Mon Sep 24 2007 Andrew Beekhof <abeekhof@suse.de>
- version 0.83-12
- Update the source tarball to revision 1495
+ make install now works properly on systems which produce wierd uname results
+ Patch to not increment the ring seq id on the first operational ring.
+ Remove & when regular reference works properly.
+ Patch to set system from field properly in retransmitted messages.
+ Make sure to unlock the handle database on a failure condition.
+ Properly daemonize and dup file descriptors to /dev/null.
+ Patch to make sure make clean works as advertised.
+ fix install broken when O=<DIR> is used
+ Allow multiple config plugins to be loaded at start time and set the config
  object database objects.
+ Force logging to stderr if the -f flag is specified.
+ srcdir is not set when realpath & abspath don't work
+ Remove closing of ttys that slipped in improperly.
+ Patch to install liblogsys
* Mon Sep 24 2007 Andrew Beekhof <abeekhof@suse.de>
- version 0.83-12
- Update the source tarball to revision 1480
- Add patches for dynamic load/unload and crm startup/shutdown
* Mon Sep 24 2007 Andrew Beekhof <abeekhof@suse.de>
- version 0.83-1
- Initial version for the build service
- Update the source tarball to revision 1452
